;program sterownika kierunkowskazow

;po wlaczeniu jesli in_prog = 0 lub eeprom(00)<>11h oczekuje na kalibracje

;kalibracja:
; 1. wlacz kierunkwskaz (lewy lub awaryjne) na 10 migniec.
; 2. koniec programowania

;ostatnie dwa bajty pam. (kalibracja) 54h, 34h
;obsluga timera timer0 - zmiana bitu LED
;bez preskalera
; ze wstepnym ustawieniem licznika na wartosc 206
;odlicza 50 cyki maszynowych (fosc/4)i zienia stan led

;definiowanie zmiennych
#define R_OUT GPIO, 0			;wyjscie kierunkowskazu R
#define L_OUT GPIO, 1			;wyjscie kierunkowskazu L
#define L_IN GPIO, 2			;wejscie sygnau z kierunkowskazu L
#define R_IN GPIO, 4			;wejscie sygnau z kierunkowskazu R
#define prog GPIO, 5			;wej. programowania GP5 - jesli programowanie =>0
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik h'22'			;pomocniczy licznik petli opoznienia
#define data_rd h'23'			;przepisanie danej z eeprom
#define stos h'24'			;pomocniczy rejestr zapamietujacy zmienne jak stos
#define time_off h'25'			;czas przez ktory nie swieci kierunkowskaz
#define time_on h'26'			;czas swiecenia kierunkowskazu
#define time h'27'			;pom. licznik czasu
#define time_dec h'28'			;pom. licznik czasu dekrementowany w timerze
#define point h'29'			;point.0 - ustawiany gdy time_dec=0

;deklaracj typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF; gen wew. RC bez wyjscia 
									;wlaczone wejscie reset
									;watch dog wylaczony
	org 0
	goto start
	
	org 4
	goto timer_int	; (2CM)
start

;wylacz komparator
	movlw .7
	movwf cmcon

;wylacz adc
	bsf status, rp0 ;bank1
	clrf ansel
	bcf status, rp0 ;bank0
	clrf gpio ;inicjalizacja portow

;konfiguracja linii i/o
	bsf status, rp0;bank1

	movlw h'3C'					;0011 1100   0=wyjscie, 1=wejscie, RST=1
	movwf trisio
	movlw h'23'					;0010 0011  rezystor pull up na GP0,1, = OUT 
	movwf wpu
	bcf option_reg, 7				;zalacza wybrane w wpu rezystory do Vdd
							;GPPU=0 w rej option_reg 7 bit zalacza rezustory z rej. wpu
	bcf status, rp0 ;bank0

;ustawienia przerwania od timera0
	bsf status, rp0	;bank1
	movlw b'00000111'	;zliczanie cykli zegarowych preskalera 1:256
	movwf option_reg
	bcf status, rp0	;bank0
	clrf intcon
	clrf tmr0	;zeruje timer0 i preskaler
	bcf intcon, t0ie	;zezwolenie na int od timer0
	bsf intcon, gie	;ogolny bit zezwolenia na przerwania on


;********************************************************
;program glowy
;***************************************************************
	call delay1s
	call delay1s
	call delay1s
	bcf R_OUT
	bcf L_OUT
	btfsc	prog		; jesli prog=1 omin nast. instr.
	goto menu2
	call prog_mem	;funkcja zapisu do eeprom uztawien poczatkowych
	goto $
menu2				;program glowny
	movlw 01h
	call eeprom_read
	movwf time_on	;odczyt z eeprom czasu swiecenia zarowek
	movlw 02h
	call eeprom_read
	movwf time_off	;odczyt z  czasu nie swiecenia zarowek
menu3
	btfss L_IN 
	goto menu4
	btfsc R_IN 
	goto menu3
	call T_L		;obsuga kierunkowskazu L
	goto menu3
menu4
	btfsc R_IN 
	call T_R
	goto menu3
;********************************************************
; funkcje pomocnicze

;obsluga przerwania od timera0
timer_int
	movwf stos; zapamietanie wartosci W
	bcf intcon, t0if	;zeruje flage przerwania (1CM)
	bcf status, rp0	;bank0			(1CM)	
	movlw .246;					;	(1CM)
	movwf tmr0					; (1CM)
	incf time, 0
	movwf time
	decfsz time_dec, 0;	zmiejsz o 1 wynik do W jesli 0 omin next instr.
	goto timer_int_end
	bsf point, 0	;znacznik wyzerowania time_dec
timer_int_end
	movwf time_dec
	movf stos, 0; W:=stos zwrot wartosci W
	retfie						;(2CM)

;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	

;opoznienie o 1 sek
delay1s
	movwf stos 	;zapamietuje W na stosie
	movlw .100
	movwf licznik
	call delay10
	decfsz licznik, f
	goto $-2
	movf stos,0	;oddaje wartosc W
	return
;odczyt z eeprom spod adr. W, dana zapisana do W
eeprom_read
	bsf status, rp0 ;bank1
	movwf eeadr		;wpisanie adresu z w eeadr
	bsf eecon1, rd	;odczyt z eeprom
	movf eedata, w	;przepisanie odczytanej danej do w
	bcf status, rp0 ;bank0
	return
;zapis do eeprom adr. W; dane data_rd
eeprom_write
	bsf status, rp0 ;bank1
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
	return
;#########################################################################

;funkcja programowania pamieci eeprom
prog_mem
;	movlw 11h;					;	
;	movwf data_rd
;	clrw			;w:=0 dres
;	call eeprom_write	; eeprom(00):=11h
;prog_mem1
	btfsc L_IN
	goto $-1
;stan L - nie swieci zarowka	
;prog_mem2
	btfss L_IN
	goto $-1;
;stan H - swieci zarowka; L->H
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	clrw
	movwf time
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
prog_mem3
	btfsc L_IN
	goto prog_mem3
;stan L - nie swieci zarowka; H->L
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movf time, 0	;W:= time
	movwf time_on	; zapis do pamieci czasu swiecenia zarowki
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	clrw
	movwf time
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
prog_mem4
	btfss L_IN
	goto prog_mem4
;stan H - swieci zarowka; L->H
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movf time, 0	;W:= time
	movwf time_off	; zapis do pamieci czasu swiecenia zarowki
	movwf data_rd
	movlw 02h;					;	
	call eeprom_write
	movf time_on, 0	;W:=time_on
	movwf data_rd
	movlw 01h;					;	
	call eeprom_write
	bsf L_OUT
	bsf R_OUT
	call delay1s
	call delay1s
	call delay1s
	bcf L_OUT
	bcf R_OUT
	return
;*****************************************************
;obsuga kierunkowskazu prawego
T_R
				;wlaczenie timera time_on, swiecnie 1
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R1
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfsc R_IN		;jesli nadal swieci R to T_R1
	goto T_R1
	btfss point, 0
	goto T_R_A		;
	btfsc R_IN		;jesli nadal swieci R to T_R4
	goto $-1
				;przerwa nr 1 swiecenia R
				;wl. timera i odliczanie time_off+2
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_2
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfss point, 0	; czu uplunal czas time_off
	goto T_R_2	
	btfss R_IN		;czy zaczal znowu swiecic R = omin next instr.
	goto T_R_B
				;drugie swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3



;	movf time_on, 0
;	movwf time_dec
;	decf time_dec, 0
;	movwf time_dec
;	decf time_dec, 0
;	movwf time_dec
;	decf time_dec, 0
;	movwf time_dec	;time_dec= time_on-3



	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_3
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfsc R_IN		;jesli nadal swieci R to T_R3
	goto T_R_3		;dokonczyc 2 migniecie i 3 cale
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_B1		;dokonczyc 2 migniecie i 3 cale
T_R_4
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_5
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_5	
	btfss R_IN		
	goto T_R_C
				;3 swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3


	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_6
	btfsc point, 0	; czu uplunal czas time_on
	goto T_R_8
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfsc R_IN		; czy nadal swieci R
	goto T_R_6
	bsf R_OUT		;zalacz R
T_R_7
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_7
	goto T_R_END	;min czas 3 migniecia
T_R_8
	btfsc R_IN		; czy nadal swieci R
	goto T_R_8
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_9
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;4 przerwa R
	btfss point, 0	; czu uplunal czas time_off
	goto T_R_9
	btfss R_IN		; czy nadal swieci R
	goto T_R_END
				;4+i swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3

	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_10
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;4 przerwa R
	btfss point, 0	; czu uplunal czas time_off
	goto T_R_10
	goto T_R_8
			
				;1 migniecie bylo nie cale cd.
T_R_A
	bsf R_OUT		; wcz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_A1
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_A1
	bcf R_OUT		; wycz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	;movwf time_dec
	;incf time_dec, 0
	;movwf time_dec
	;incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_A2
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_A2
T_R_B
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_B1
	bsf R_OUT		; wcz R - 2 migniecie
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_B1
	bcf R_OUT		; wycz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_B2
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_B2
T_R_C
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_R_C1
	bsf R_OUT		; wcz R - 3 migniecie
	btfsc L_IN		;jesli wyl. L omja next instr.
	goto T_R_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_R_C1
T_R_END
	bcf R_OUT		;wycz R
	call delay1s
	return
;*****************************************************
;obsuga kierunkowskazu lewego
T_L
				;wlaczenie timera time_on, swiecnie 1
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L1
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfsc L_IN		;jesli nadal swieci R to T_R1
	goto T_L1
	btfss point, 0
	goto T_L_A		;
	btfsc L_IN		;jesli nadal swieci R to T_R4
	goto $-1
				;przerwa nr 1 swiecenia R
				;wl. timera i odliczanie time_off+2
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_2
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfss point, 0	; czu uplunal czas time_off
	goto T_L_2	
	btfss L_IN		;czy zaczal znowu swiecic R = omin next instr.
	goto T_L_B
				;drugie swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_3
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfsc L_IN		;jesli nadal swieci R to T_R3
	goto T_L_3		;dokonczyc 2 migniecie i 3 cale
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_B1		;dokonczyc 2 migniecie i 3 cale
T_L_4
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_5
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_5	
	btfss L_IN		
	goto T_L_C
				;3 swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3

	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_6
	btfsc point, 0	; czu uplunal czas time_on
	goto T_L_8
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfsc L_IN		; czy nadal swieci R
	goto T_L_6
	bsf L_OUT		;zalacz R
T_L_7
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_7
	goto T_L_END	;min czas 3 migniecia
T_L_8
	btfsc L_IN		; czy nadal swieci R
	goto T_L_8
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec
	incf time_dec, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_9
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END	;4 przerwa R
	btfss point, 0	; czu uplunal czas time_off
	goto T_L_9
	btfss L_IN		; czy nadal swieci R
	goto T_L_END
				;4+i swiecenie R
				;wlaczenie time_on
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)

	movlw .3
	subwf time_on, 0
	movwf time_dec	;time_dec= time_on-3

	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_10
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END	;4 przerwa R
	btfss point, 0	; czu uplunal czas time_off
	goto T_L_10
	goto T_L_8
			
				;1 migniecie bylo nie cale cd.
T_L_A
	bsf L_OUT		; wcz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_A1
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END	;
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_A1
	bcf L_OUT		; wycz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_A2
	btfsc R_IN		;jesli wyl. L omja next instr.
	goto T_L_END	;
	btfss point, 0	; czu uplunal czas time_off
	goto T_L_A2
T_L_B
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_B1
	bsf L_OUT		; wcz R - 2 migniecie
	btfsc R_IN		;jesli wyl. L omja next instr.	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto T_L_END	;						!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_B1
	bcf L_OUT		; wycz R
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_off, 0
	movwf time_dec	; wydluzenie czasu time_off o 2 przerwania
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_B2
	btfsc R_IN		;jesli wyl. L omja next instr.	!!!!!!!!!!!!!!!!!!!!!!!!
	goto T_L_END	;						!!!!!!!!!!!!!!!!!!!!!!!!
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_B2
T_L_C
	bcf intcon, t0ie	;ogolny bit zezwolenia na przerwania off
	movlw .246;					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	movf time_on, 0
	movwf time_dec
	bcf point, 0
	bsf intcon, t0ie	;ogolny bit zezwolenia na przerwania on
T_L_C1
	bsf L_OUT		; wcz R - 3 migniecie
	btfsc R_IN		;jesli wyl. L omja next instr.  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto T_L_END	;						!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	btfss point, 0	; czu uplunal czas time_on
	goto T_L_C1
T_L_END
	bcf L_OUT		;wycz L
	call delay1s
	return
;****************************************************************************
	end
